clear all;
close all;
clc

format long
% curr = xlsread('currFil',1); %read real voltage and current from excel
% volt = xlsread('volt',1);
% save curr;
% save volt;
% VT = 1.3806e-23*(273.15+33)/1.602e-19;

NP=100;
N_iter = 100;
Fun_Num = 13;

RunTimes=50;

PCE_fmins = zeros(1,RunTimes); %record fmin of each run for f1~f13 or f30~f31

PCE_NFESs = zeros(1,RunTimes); %record NFES of each run for f1~f13 or f30~f31

PCE_NFES_CNT = 0;

PCE_SR = 0;

PCE_meanf = zeros(1,Fun_Num);

PCE_stdf = zeros(1,Fun_Num);

PCE_ANFESf = zeros(1,Fun_Num);
PCE_NFESstdf = zeros(1,Fun_Num);

PCE_SRf = zeros(1,Fun_Num);

PCE_fmin_frun = zeros(Fun_Num,RunTimes);
PCE_fmin_sfrun = zeros(1,RunTimes);
PCE_fmin_dfrun = zeros(1,RunTimes);

PCE_bestf1 = zeros(RunTimes,5);
PCE_bestf2 = zeros(RunTimes,7);

for f=30:31 % Name of the benchmarks functions that can be from F1 to F13 (f=1:13); For solar cell models using F30 and F31 (f=30:31)
for run=1:RunTimes
  fprintf('run = %ith / f%i ',run,f);
  fprintf('\n')

Function_name = ['F', num2str(f)];
% Load details of the selected benchmark function
[lb,ub,Nvar,Fun]=Get_Functions_details(Function_name);

if size(ub,2)==1
    ub=ones(1,Nvar)*ub;
    lb=ones(1,Nvar)*lb;
end

%%------here for f30~f31---------
if(f == 30)
maxFES = 10000;
else
maxFES = 20000;    
end
%%----------------------------
% maxFES = 10000*Nvar; %for f1~f13

start1 = cputime;
[PCE_fmin,PCE_best,PCE_NFES] = pce_main(maxFES, NP, N_iter, Nvar, Fun, lb, ub, f);
PCE_time = cputime - start1;
PCE_fmin

PCE_fmins(run) = PCE_fmin;

%%------here for f30~f31---------
if(f==30)
PCE_bestf1(run,:) = PCE_best;
else
PCE_bestf2(run,:) = PCE_best;
end
%%----------------------------

PCE_NFESs(run) = PCE_NFES;

PCE_fmin_frun(f-29, run) = PCE_fmin;

if(PCE_NFES~=0)
    PCE_NFES_CNT = PCE_NFES_CNT + 1;
end

end

%%   mean 
PCE_meanf(f-29) = mean(PCE_fmins);

% %   std
PCE_stdf(f-29) = std(PCE_fmins);

% %   aNFES
PCE_ANFESf(f-29) = mean(PCE_NFESs);
PCE_NFESstdf(f-29) = std(PCE_NFESs);

PCE_SRf(f-29) = PCE_NFES_CNT/50;

PCE_NFES_CNT = 0;

end
PCE_meanf
PCE_stdf
PCE_ANFESf
PCE_NFESstdf
PCE_SRf
PCE_fmin_frun
PCE_bestf1
PCE_bestf2
PCE_fmin_sfrun = PCE_fmin_frun(1,:);
PCE_fmin_dfrun = PCE_fmin_frun(2,:);
[A, index1] = min(PCE_fmin_sfrun);
[A0, index10] = max(PCE_fmin_sfrun);
index1
index10
[B, index2] = min(PCE_fmin_dfrun);
[B0, index20] = max(PCE_fmin_dfrun);
index2
index20
