clc;
clear all;  
format long; 

load curr;
load volt;

mode = 2;

if(mode==1)
    VT = 1.3806e-23*(273.15+33)/1.602e-19;
    Rs = 0.0363770925216135;
    Rsh = 53.7185247843113;
    Iph = 0.760775529924908; 
    Isd = 0.323020820736446;
    n = 1.48107441796455;
    lse = 0;
    len = length(volt);
    %Calculate the lse
    CurrCal = zeros(len,1);
    for m = 1:len
    %         answer=bisect(@(x)((Iph -Isd *1e-6*(exp((volt(m,1)+ Rs*x)/(n*VT)) - 1 ) - (volt(m,1)+ Rs*x)/Rsh)-x),-1,1,1e-8);
    answer  = (Iph -Isd *1e-6*(exp((volt(m,1)+ Rs*curr(m,1))/(n*VT)) - 1 ) - (volt(m,1)+ Rs*curr(m,1))/Rsh);
    CurrCal(m,1)=answer;
    lse = lse + (answer-curr(m,1))^2;
    end
    lse = (lse/len)^0.5;


else
    VT = 1.3806e-23*(273.15+33)/1.602e-19;
    Isd1 = 0.749339706032965;
    Isd2 = 0.226014537641041;
    n1 = 2;
    n2 = 1.45092286270028;
    Rs = 0.0367404389959328; 
    Rsh = 55.4831604544622;
    Iph = 0.760781131513987;
    lse = 0;
    len = length(volt);
    CurrCal = zeros(len,1);
    %Calculate the lse
    for m = 1:len
%         CurrCal(m,1)  = (Iph -Isd *1e-6*(exp((volt(m,1)+ Rs*curr(m,1))/(n*VT)) - 1 ) - (volt(m,1)+ Rs*curr(m,1))/Rsh);
%         lse = lse + (CurrCal(m,1)-curr(m,1))^2;
%          answer=bisect(@(x)((Iph -Isd1 *1e-6*(exp((volt(m,1)+ Rs*x)/(n1*VT)) - 1 ) - Isd2 *1e-6*(exp((volt(m,1)+ Rs*x)/(n2*VT)) - 1 )-(volt(m,1)+ Rs*x)/Rsh)-x),-1,1,1e-8);
%         currcal(m,1)=answer;
    CurrCal(m,1)  = Iph -Isd1 *1e-6*(exp((volt(m,1)+ Rs*curr(m,1))/(n1*VT)) - 1 ) - Isd2 *1e-6*(exp((volt(m,1)+ Rs*curr(m,1))/(n2*VT)) - 1 )-(volt(m,1)+ Rs*curr(m,1))/Rsh;
%         lse = lse + (answer-curr(m,1))^2;
    lse = lse + (CurrCal(m,1)-curr(m,1))^2;
    end
    lse = (lse/len)^0.5;
    
end

aa=figure;
plot(volt,curr,'ro', 'LineWidth',1.2);
hold on
% plot(volt,curr,'b*', 'LineWidth',1.2);
% hold on
plot(volt,CurrCal,'b*', 'LineWidth',1.2);
xlabel('Voltage (V)','FontSize',14);
ylabel('Current (A)','FontSize',14);
grid on;
h=legend('real data', 'simulated data', 'Location','NorthEast','FontSize',14);
set(h,'Fontsize',12);
bb=title('Double diode model');
set(bb,'FontSize',14);
print -f1 -r300 -djpeg myfigure;